include \masm32\include\masm32rt.inc
include Shift64.inc		; contains the shl64 and shr64 macros

.data
MyQw1	dq 1234567812345678h
MyQw2	dq 1234567812345678h
MyQw3	dq 1234567812345678h

.code
start:
	shiftLeft		= 40
	shiftRight	= 40
	print "Original value: ", 13, 10
	print xqword$(MyQw1), 13, 10

	mov eax, offset MyQw1		; pass ptr to qword in a register
	shl64 eax, shiftLeft
	print xqword$(MyQw1), 13, 10
	mov eax, offset MyQw1
	shr64 eax, shiftRight
	print xqword$(MyQw1), 13, 10

	mov ecx, shiftLeft
	shl64 MyQw2, cl		; pass qword directly, shiftcount in byte register
	print xqword$(MyQw2), 13, 10
	mov ecx, shiftRight
	shr64 MyQw2, cl
	print xqword$(MyQw2), 13, 10

	shl64 offset MyQw3, shiftLeft	; pass offset qword, shiftcount as immediate
	print xqword$(MyQw3), 13, 10
	shr64 offset MyQw3, shiftRight
	print xqword$(MyQw3), 13, 10, 10

	getkey
	exit				; short form of invoke ExitProcess, 0

end start

RichMasm options:
OxPT_Linker	link	; If present in \bin, PoLink.exe will be used by default; delete the x to force link.exe
OxPT_Assembler	JWasm	; If present in \bin, JWasm.exe may be used: just delete the x 
OPT_DebugL	/MERGE:.data=.rdata /MERGE:.rdata=.text	; for ultra short executables
OPT_NoWarn	LNK4254, multiple	; we ignore linker warnings found in this string, e.g. section a merged into b with different attributes
OPT_WAIT	0		; wait until a key is pressed before closing the DOS box
OPT_Tmp2Asm	1
