;; simple, fast and non-SSE2, 29 bytes ****
shl64 MACRO arg, ct
Local oa, oc, is, arg1, c1		; trashes edx and eax
  oc = (opattr ct) AND 127
  if oc eq 48	;; register
	tmp$ CATSTR <*** ERROR: invalid counter >, <ct>, < - use cl ***>
	c1 SUBSTR <ct>, 1, 1
	ifidni <ct>, <al>
	  	echo
  		.err tmp$
	elseifidni <ct>, <dl>
	  	echo
	  	.err tmp$
	elseifidni c1, <e>
	  	echo
		.err <*** ERROR: byte register needed as counter ***>
	endif
  endif
  arg1 equ arg
  is INSTR <arg>, < >
  if is eq 7
	arg1 SUBSTR <arg>, 1, 6
	ifidni arg1, <offset>
		arg1 SUBSTR <arg>, 8
	else
		arg1 equ arg
	endif
  endif 
  oa = (opattr arg1) AND 127
  if oa eq 42					; MyQword (immediate label)
	mov eax, dword ptr arg1
	mov edx, dword ptr arg1[4]
	if oc eq 36				; immediate
		if ct gt 32
			mov edx, dword ptr arg1
			shl edx, ct-32
			mov dword ptr arg1, 0
			mov dword ptr arg1[4], edx
		else
			mov eax, dword ptr arg1
			mov edx, dword ptr arg1[4]
			shld edx, eax, ct
			shl eax, ct
			mov dword ptr arg1, eax
			mov dword ptr arg1[4], edx
		endif
	else
		.if ct > 32
			mov edx, dword ptr arg1
			sub ct, 32
			shl edx, ct
			mov dword ptr arg1, 0
			mov dword ptr arg1[4], edx
		.else
			mov eax, dword ptr arg1
			mov edx, dword ptr arg1[4]
			shld edx, eax, ct
			shl eax, ct
			mov dword ptr arg1, eax
			mov dword ptr arg1[4], edx
		.endif
	endif
  elseif oa eq 48				; register = offset MyQword 
	oa = 0
	if oc eq 36				; immediate
		if ct gt 32
			oa = 1			; only immediate can have ct>32
		endif
	endif
	if oa
		mov edx, dword ptr [arg]
		shl edx, ct-32
		mov dword ptr [arg], 0
		mov dword ptr [arg+4], edx
	else
		push ecx
		push arg
		mov edx, [arg+4]
		mov eax, [esp]
		mov eax, [eax]
		shld edx, eax, ct
		shl eax, ct
		pop ecx
		mov [ecx], eax
		mov [ecx+4], edx
		pop ecx
	endif
  else
  	tmp$ CATSTR <*** Invalid operand >, <arg>, <, opat=>, %oa
  	.err tmp$
  endif
ENDM

shr64 MACRO arg, ct
Local oa, oc, is, arg1, c1		; trashes edx and eax
  oc = (opattr ct) AND 127
  if oc eq 48	;; register
	tmp$ CATSTR <*** ERROR: invalid counter >, <ct>, < - use cl ***>
	c1 SUBSTR <ct>, 1, 1
	ifidni <ct>, <al>
		echo
		.err tmp$
	elseifidni <ct>, <dl>
		echo
		.err tmp$
	elseifidni c1, <e>
		echo
		.err <*** ERROR: byte register needed as counter ***>
	endif
  endif
  arg1 equ arg
  is INSTR <arg>, < >
  if is eq 7
	arg1 SUBSTR <arg>, 1, 6
	ifidni arg1, <offset>
		arg1 SUBSTR <arg>, 8
	else
		arg1 equ arg
	endif
  endif 
  oa = (opattr arg1) AND 127
  if oa eq 42					; MyQword (immediate label)
	mov eax, dword ptr arg1
	mov edx, dword ptr arg1[4]
	if oc eq 36				; immediate
		if ct gt 32
			mov edx, dword ptr arg1[4]
			shr edx, ct-32
			mov dword ptr arg1[4], 0
			mov dword ptr arg1, edx
		else
			mov eax, dword ptr arg1
			mov edx, dword ptr arg1[4]
			shrd eax, edx, ct
			shr edx, ct
			mov dword ptr arg1, eax
			mov dword ptr arg1[4], edx
		endif
	else
		.if ct > 32
			mov edx, dword ptr arg1[4]
			sub ct, 32
			shr edx, ct
			mov dword ptr arg1[4], 0
			mov dword ptr arg1, edx
		.else
			mov eax, dword ptr arg1
			mov edx, dword ptr arg1[4]
			shrd eax, edx, ct
			shr edx, ct
			mov dword ptr arg1, eax
			mov dword ptr arg1[4], edx
		.endif
	endif
  elseif oa eq 48				; register = offset MyQword 
	oa = 0
	if oc eq 36				; immediate
		if ct gt 32
			oa = 1			; only immediate can have ct>32
		endif
	endif
	if oa
		mov edx, dword ptr [arg+4]
		shr edx, ct-32
		mov dword ptr [arg+4], 0
		mov dword ptr [arg], edx
	else
		push ecx
		push arg
		mov edx, [arg+4]
		mov eax, [esp]
		mov eax, [eax]
		shrd eax, edx, ct
		shr edx, ct
		pop ecx
		mov [ecx], eax
		mov [ecx+4], edx
		pop ecx
	endif
  else
  	tmp$ CATSTR <*** Invalid operand >, <arg>, <, opat=>, %oa
  	.err tmp$
  endif
ENDM
